%% toolKIT.sty: definition of various macros
%% ====================================================
%% Author: Dr. Thomas Hertweck, Thomas.Hertweck@kit.edu
%% ====================================================

\ProvidesPackage{toolKIT}[2025/02/28 v2.0 miscellaneous features for KIT beamer theme]

\RequirePackage{xparse}
\RequirePackage{xifthen}
\RequirePackage{tikz}
\RequirePackage{colorKIT}
\RequirePackage{tcolorbox}

%% KITheading
\DeclareDocumentCommand \KITheading { m } {%
  \vspace{1ex plus 0.2ex minus 0.2ex}\par{\textbf{#1}\par}%
}

%% KITstatement
\DeclareDocumentCommand \KITstatement { m } {%
  \vspace{1ex plus 0.2ex minus 0.2ex}\par{\Large\textcolor{KITbluegreen}{\textbf{#1}}\par}%
}

%% KITroman
\newcommand{\KITroman}[1]{\uppercase\expandafter{\romannumeral #1\relax}}

%% KITimage
\DeclareDocumentCommand \KITimage { o m O{south west} +d() o } {%
\begin{tikzpicture}%
\IfValueTF{#1}{\node[inner sep=0pt,outer sep=0pt] (img) {\includegraphics[#1]{#2}};}%
              {\node[inner sep=0pt,outer sep=0pt] (img) {\includegraphics{#2}};}%
\IfValueT{#4}{\node[inner sep=2pt,outer sep=0pt,anchor=south west,font=\Tiny,KITblack,#5] at (img.#3) {#4};}%
\end{tikzpicture}%
}

%% KITvimage
\newcommand{\kit@vimage@logo}{\@empty}
\newcommand{\kit@vimage@unilogo@file}{\@empty}
\define@choicekey*{vimage}{logo}{white,black,color,none}[color]{\renewcommand{\kit@vimage@logo}{#1}}
\presetkeys{vimage}{logo=color}{}
\DeclareDocumentCommand \KITvimage { o m O{south west} +d() o } {%
  \IfValueTF {#1} {\setkeys{vimage}{#1}}{\setkeys{vimage}{}}
  \settowidth{\kit@tmpwid}{\includegraphics[height=\kit@paper@height]{#2}}
  \newgeometry{textwidth=\dimexpr\textwidth-\kit@tmpwid}
  \renewcommand{\kit@vimage@unilogo@file}{corefig/kitlogo_color}
  \ifthenelse{\equal{\kit@vimage@logo}{none}}{\renewcommand{\kit@vimage@unilogo@file}{\@empty}}{}
  \ifthenelse{\equal{\kit@vimage@logo}{black}}{\renewcommand{\kit@vimage@unilogo@file}{corefig/kitlogo_black}}{}
  \ifthenelse{\equal{\kit@vimage@logo}{white}}{\renewcommand{\kit@vimage@unilogo@file}{corefig/kitlogo_white}}{}
  \begin{textblock*}{\kit@paper@width}(0pt,0pt)
    \begin{tikzpicture}%
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      \node[inner sep=0pt,outer sep=0pt,anchor=south east] (vimg) at (\kit@paper@width,0pt) {%
        \includegraphics[height=\kit@paper@height]{#2}%
      };
      \ifthenelse{\equal{\kit@vimage@unilogo@file}{\@empty}}{}{%
        \node[inner sep=0pt,outer sep=0pt,anchor=south east] at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty)%
        {\href{https://www.kit.edu}{\includegraphics[width=\kit@footer@unilogo@width]{\kit@vimage@unilogo@file}}};%
      }%
      \IfValueT{#4}{\node[inner sep=2pt,outer sep=0pt,anchor=south west,font=\Tiny,KITblack,#5] at (vimg.#3) {#4};}%
      % put navigation symbols back on top
%      \ifthenelse{\boolean{kit@nav@use}}{%
%        \pgftext[at=\pgfpoint{\kit@paper@width-\kit@text@marginright}{\kit@paper@height},top,right]%
%          {\usebeamercolor*[fg]{navigation symbols}\expandafter\kit@ins@nav\kit@nav@syms}%
%      }{}%
    \end{tikzpicture}%
  \end{textblock*}
}

%% KITframe
\newtcolorbox{KITframe}[1]{%
enhanced,left=0pt,right=0pt,top=0pt,bottom=0pt,boxrule=0.5pt,notitle,colframe=KITdarkblue,%
colback=KITwhite,coltext=KITdarkblue,halign=flush left,valign=top,width=\textwidth,sharp corners,#1}

%% KITbox
\newtcbox{\KITbox}[1]{%
on line,sharp corners,boxrule=0.5pt,notitle,left=0pt,right=0pt,top=0pt,bottom=0pt,%
colframe=KITdarkblue,colback=KITwhite,coltext=KITdarkblue,#1}

%% KITmessage
\newtcolorbox{KITmessage}[2][]{%
enhanced,boxsep=3pt,top=1.8ex,bottom=1ex,left=0.2em,right=0.2em,boxrule=0.5pt,toptitle=2pt,%
bottomtitle=2pt,squeezed title={#2},fonttitle=\bfseries,sharp corners,colback=KITwhite,%
attach boxed title to top left={yshift=-2.5mm,xshift=1.5mm},colbacktitle=KITdarkblue,%
boxed title style={colframe=KITdarkblue,boxrule=0.5pt,left=0.6em,right=0.6em},%
coltext=KITdarkblue,valign=top,drop fuzzy shadow,#1}

%% KITnote
\newtcolorbox{KITnote}[2][]{%
enhanced,boxsep=3pt,top=2pt,bottom=2pt,left=1pt,right=1pt,boxrule=0.5pt,toptitle=2pt,%
bottomtitle=2pt,squeezed title={#2},fonttitle=\bfseries,sharp corners,colback=KITwhite,%
colbacktitle=KITdarkblue,halign=flush left,halign title=flush left,coltext=KITdarkblue,%
valign=top,drop fuzzy shadow,#1}



